<?php
/* utf8-marker = äöüß */

/*
 * Remotecontent_XH
 *
 * @author Olaf Penschke
 * @version 1.1 (28.02.2018)
 * @link    http://olaf.penschke.net/
 * @license http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
================================================================================

olape

================================================================================

externe Inhalte in eine Seite einbinden
Aufruf mit:

======================================
html-Datei mit Authentifizierung einbinden
	{{{op_extern_content('https://domain.tld/userfiles/extern_content/datei.htm', '16-stelliges-AuthToken', 'fiktive_Browserkenneung', 'Art des Inhalts (txt, html, fullhtml', 'Wenn javaScript erhalten bleiben soll, dann js');}}}
		
		CURLOPT_USERAGENT, authtoken und IP der Webseite/des Server sind, für dieses Beispiel in "/userfiles/extern_content/.htaccess" als Regel für den Zugriff festgelegt.

======================================
	Druckausgabe von CMSimple einbinden (Urheberrechte beachten!!!)
		{{{op_extern_content('http://domain.tld/?IrgendeineSeite&print', '', '', 'fullhtml', 'js');}}}

	txt --> reine Textdatei
	html --> Boilerplate_XH Textblock
	fullhtml --> vollständige html-Datei (html, head, body, ...)

	js --> wenn gesetzt, wird JavaScript nicht gefiltert


================================================================================
*/

/*
 * Check if PLUGINLOADER is calling and die if not.
 */
if(!defined('PLUGINLOADER')) {
	die(
		'Plugin '. basename(dirname(__FILE__))
		. ' requires a newer version of the Pluginloader. No direct access.'
	);
}

//******************************************************************************

function op_extern_content($op_ext_url = '', $op_authtoken = '', $op_useragent = '', $op_sourceformat = 'fullhtml', $op_js = '')
{

global $plugin_cf, $plugin_tx;

$op_output = '';

//******************************************************************************
//Authentifizierungtoken, wenn vorhanden, an URL anhängen
	if ($op_authtoken != '') {
		$op_ext_new_url = $op_ext_url . '?authtoken=' . $op_authtoken;
	} else {
		$op_ext_new_url = $op_ext_url;
	}

//******************************************************************************
//UserAgent setzen
	if ($op_useragent == '') {
		//$op_useragent = "Mozilla/5.0 (Windows NT 5.1; rv:31.0) Gecko/20100101 Firefox/31.0";
		//$op_useragent = "Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html";		//als Googlebot 'tarnen'
		$op_useragent = 'Remotecontent_XH';
	}

//******************************************************************************
//config
	if($plugin_cf['remotecontent']['verbose'] == 'true') {
		$op_header = true;
		$op_verbose = true;
	} else {
		$op_header = false;
		$op_verbose = false;
	}

	$op_maxdirs = $plugin_cf['remotecontent']['curlopt_maxredirs'];
	settype($op_maxdirs, "integer");

	$op_connecttimeout = $plugin_cf['remotecontent']['curlopt_connecttimeout'];
	settype($op_connecttimeout, "integer");

	$op_timeout = $plugin_cf['remotecontent']['curlopt_timeout'];
	settype($op_timeout, "integer");

	if($plugin_cf['remotecontent']['curlopt_ssl_verifyhost'] == '2') {
		$op_ssl_verifyhost = 2;
	} else {
		$op_ssl_verifyhost = false;
	}

//******************************************************************************
// caching
	$op_cachetime = $plugin_cf['remotecontent']['cache_time'];
	$op_cachedir = __DIR__ . '/cache/';

	$op_hash = md5($op_ext_url);
	$op_cachefile = $op_cachedir . $op_hash . '.cache';

	$op_time = 0;
	if(file_exists($op_cachefile)) {
		$op_time = filemtime($op_cachefile);
	}
	$op_filetimemod = $op_time + $op_cachetime;

	if($op_filetimemod < time()) {

//******************************************************************************
// cURL
		//Postdaten für Abfrage
			//$op_curl_data = '';

		//Seitenaufruf
		$op_ch = curl_init();
			$op_options = array(														// http://php.net/manual/de/function.curl-setopt.php
				CURLOPT_URL            => $op_ext_new_url,								//
				CURLOPT_USERAGENT      => $op_useragent,								//
				CURLOPT_HTTPHEADER     => array('Accept-Language: de-DE,de;q=0.5'),		//
				CURLOPT_RETURNTRANSFER => true,											// return web page
				CURLOPT_HEADER         => $op_header,									// don't return headers
				CURLOPT_FOLLOWLOCATION => true,											// follow redirects
				CURLOPT_MAXREDIRS      => $op_maxdirs,									// stop after x redirects
				CURLOPT_ENCODING       => "",											// handle all encodings
				CURLOPT_AUTOREFERER    => true,											// set referer on redirect
				CURLOPT_CONNECTTIMEOUT => $op_connecttimeout,							// timeout on connect
				CURLOPT_TIMEOUT        => $op_timeout,									// timeout on response
				//CURLOPT_POST           => 1,											// sending post data
				//CURLOPT_POSTFIELDS     => $op_curl_data,								// this are the post vars
				CURLOPT_SSL_VERIFYHOST => $op_ssl_verifyhost,							// false = don't verify ssl, 1 = Check the existence of a common name in the SSL peer certificate, 2 = Check the existence of a common name and also verify that it matches the hostname provided.
				CURLOPT_SSL_VERIFYPEER => true,											//
				CURLOPT_VERBOSE        => $op_verbose,									// ausführliche Informationen
				//CURLOPT_FILE           => $file,										// Die Datei, in die der Transfer geschrieben werden soll. Standard ist STDOUT (der Browser).
				//CURLOPT_USERPWD        => loginname:passwort,							// ?
			);
			curl_setopt_array($op_ch, $op_options);
			$op_rueckgabe = curl_exec($op_ch);
			$op_curl_info = curl_getinfo($op_ch);
			curl_close($op_ch);

		if($op_rueckgabe !== false) {
			file_put_contents($op_cachefile, $op_rueckgabe);													// Daten in Cachefile schreiben
		} else {
			file_put_contents($op_cachefile, '<p>Last HTTP-Code: ' . $op_curl_info['http_code']);
		}
	} else {
		$op_rueckgabe = file_get_contents($op_cachefile);														// Daten aus Cachefile lesen
	}

//******************************************************************************
//Nachbearbeitung der Daten
		$op_tmp_output = '';
		if($op_sourceformat == 'txt') {																			// reine Textdatei
			$op_tmp_output = nl2br($op_rueckgabe);
		} else if($op_sourceformat == 'html') {																	// Boilerplate_XH Textblock
			$op_tmp_output = $op_rueckgabe;
		} else {																								// vollständige html-Datei (html, head, body, ...)
			if($plugin_cf['remotecontent']['verbose'] == 'true') {												// zusätzlich header ausgeben
				$op_header_array = explode('<', $op_rueckgabe);
				$op_tmp_output .= $op_header_array[0];
			}
			preg_match('#\<body[^>]*\>(.*)\<\/body\>#Uis', $op_rueckgabe, $op_rueckgabe_found); 				// nur den Inhalt zwischen <body> und </body>
			if(!(empty($op_rueckgabe_found[1]))) {
				$op_tmp_output .= $op_rueckgabe_found[1];
			} else {
				$op_tmp_output .= '';
			}
		}
		$op_tmp_output = preg_replace('#\{\{\{[^\}]*\}\}\}#', '', $op_tmp_output); 								// entfernt {{{ .... }}} z.B. {{{PLUGIN:video(..., oder {{{XH_mailform();}}}
		$op_tmp_output = preg_replace('#\#CMSimple[^\#]*\##Uuis', '', $op_tmp_output);							// entfernt #CMSimple ....;# z.B. #CMSimple $druck="no";#
		$op_tmp_output = preg_replace('#\<iframe[^\>]*\>.*?\<\/iframe\>#umsi', '',  $op_tmp_output);			// iFrames entfernen
		//$op_tmp_output = preg_replace('#\<div[^\>]*\>[\s]*\<\/div\>#Uis', '',  $op_tmp_output);					// leere divs entfernen <div></div>, <div> </div>, <div class="..."></div>, ...
		$op_tmp_output = preg_replace('#\<\!\-\-[^\-\-\>]*\-\-\>#Uis', '', $op_tmp_output); 					// HTML Kommentare entfernen
		if(!($op_js == 'js')) {
			$op_tmp_output = preg_replace('#\<script[^\>]*\>.*?\<\/script\>#umsi', '', $op_tmp_output);			// entfernt JavaScript
			$op_tmp_output = preg_replace('#\<noscript[^\>]*\>.*?\<\/noscript\>#umsi', '', $op_tmp_output);		// entfernt NoScript
		}

		if(($op_sourceformat == 'txt') || ($op_sourceformat == 'fullhtml')) {
			$op_tmp_output = '<blockquote id="ext_cont_blockquote" cite="' 
			. $op_ext_url 
			. '">' 
			. $op_tmp_output 
			. '</blockquote>' 
			. "\n";
			$op_copyright_domain = parse_url($op_ext_url);
			$op_tmp_output.= '<div id="ext_cont_copyright">' 
			. $plugin_tx['remotecontent']['source'] 
			. '<a target="_blank" href="' 
			. $op_copyright_domain['scheme'] 
			. '://' . $op_copyright_domain['host'] 
			. '/">' . $op_copyright_domain['host'] . '</a></div>'
			. "\n";
		}

//******************************************************************************
// temp. Ausgabe, wenn $plugin_cf['remotecontent']['verbose'] = true
	if($plugin_cf['remotecontent']['verbose'] == 'true') {
		$op_tmp_output.= '<hr>' . "\n";
		$op_tmp_output.= 'URL: ' . $op_ext_url . '<br>' . "\n";
		$op_tmp_output.= 'Authtoken: ' . substr($op_authtoken, 0, 3) . ' ... ' . substr($op_authtoken, -3) . '<br>' . "\n";
		$op_tmp_output.= 'UserAgent: ' . substr($op_useragent, 0, 3) . ' ... ' . substr($op_useragent, -3) . '<br>' . "\n";
		$op_tmp_output.= 'Quellformat: ' . $op_sourceformat . '<br>' . "\n";
		$op_tmp_output.= '<hr>' . "\n";
		$op_tmp_output.= 'op_header: ' . $op_header . '<br>' . "\n";
		$op_tmp_output.= 'op_maxdirs: ' . $op_maxdirs . '<br>' . "\n";
		$op_tmp_output.= 'op_connecttimeout: ' . $op_connecttimeout . '<br>' . "\n";
		$op_tmp_output.= 'op_timeout: ' . $op_timeout . '<br>' . "\n";
		$op_tmp_output.= 'op_ssl_verifyhost: ' . $op_ssl_verifyhost . '<br>' . "\n";
		$op_tmp_output.= '<hr>' . "\n";
		if(isset($op_curl_info)) {
		$op_tmp_output.= 'SSL Verify Result: ' . $op_curl_info['ssl_verify_result'] . '<br>' . "\n";
		$op_tmp_output.= 'Speed Download: ' . $op_curl_info['speed_download'] . '<br>' . "\n";
		$op_tmp_output.= 'Total Time: ' . $op_curl_info['total_time'] . '<br>' . "\n";
		$op_tmp_output.= 'Last HTTP-Code: ' . $op_curl_info['http_code'] . '<br>' . "\n";
		$op_tmp_output.= '<hr>' . "\n";
		}
		$op_tmp_output.= 'URL-Hash: ' . $op_hash . '<br>' . "\n";
		$op_tmp_output.= 'Cache_Dir: ' . $op_cachedir . '<br>' . "\n";
		$op_tmp_output.= 'Cache_File: ' . $op_cachefile . '<br>' . "\n";
		$op_tmp_output.= 'File_Time: ' . date('F d Y H:i:s', $op_time) . '<br>' . "\n";
		$op_tmp_output.= 'Cache_Time: ' . $op_cachetime . '<br>' . "\n";
		
	}
// Ende temp. Ausgabe

//******************************************************************************
	$op_output = $op_tmp_output;
	return $op_output;
}

?>